#include <assert.h>
#include <stdio.h>
#include "libtsctl.h"
#include "Array.h"
#include "arch.h"

#define DIOTEST(x,y) DIOTest(dio,#x,x,#y,y)

int DIOTestSub(DIO *dio,int expect,char *name1,int dio1,char *name2,int dio2) {
  int rb,ret = 1;
  dio->SetAsync(dio,dio1,INPUT);
  dio->SetAsync(dio,dio2,INPUT);

  dio->SetAsync(dio,dio1,DIOValue(expect));

  if ((rb=dio->GetAsync(dio,dio2)) != expect) {
    printf("%s set %s, %s read as %s\n",name1,DIOValueString(DIOValue(expect)),
	   name2,DIOValueString(rb));
    ret=0;
  }
  dio->SetAsync(dio,dio1,INPUT);
  dio->SetAsync(dio,dio2,INPUT);
  return ret;
}

int DIOTest(DIO *dio,char *name1,int dio1,char *name2,int dio2) {
  if (!DIOTestSub(dio,INPUT_LOW,name1,dio1,name2,dio2)) return 0;
  if (!DIOTestSub(dio,INPUT_HIGH,name1,dio1,name2,dio2)) return 0;
  return 1;
}

int DIOSetValue(DIO *dio,int dio0,int dio1,int dio2,int val) {
  dio->SetAsync(dio,dio0,(val & 1) ? HIGH:LOW);
  dio->SetAsync(dio,dio1,(val & 2) ? HIGH:LOW);
  dio->SetAsync(dio,dio2,(val & 4) ? HIGH:LOW);
}

int main() {
  System *sys = SystemInit(0);
  DIO *dio = DIOInit(0);

  int RESET_RLY1, SET_RLY1, RESET_RLY2, SET_RLY2, EN_RLY3, EN_RLY4, ISO_IN1,
    ISO_IN2, EN_ISO_OUT1_N, EN_ISO_OUT2_N, IN_DIO_1, EN_HS_OUT1, IN_DIO_2,
    EN_HS_OUT2, IN_DIO_3, EN_LS_OUT_3, IN_DIO_4, EN_LS_OUT_4, ADC_CLK,
    BUF_ADC_DATA, ADC_CS_N, SBC_ADC_SEL0, SBC_ADC_SEL1, SBC_ADC_SEL2, 
    SBC_GAIN_0, SBC_GAIN_1;

  // allocate new region to hold ASCIIZ strings
  // replace ASCIIZ with region based version
  assert((RESET_RLY1=sys->MapLookup(sys,ASCIIZ("CN2_58"))) >= 0);
  assert((SET_RLY1=sys->MapLookup(sys,ASCIIZ("CN2_56"))) >= 0);
  assert((RESET_RLY2=sys->MapLookup(sys,ASCIIZ("CN2_62"))) >= 0);
  assert((SET_RLY2=sys->MapLookup(sys,ASCIIZ("CN2_60"))) >= 0);
  assert((EN_RLY3=sys->MapLookup(sys,ASCIIZ("CN2_64"))) >= 0);
  assert((EN_RLY4=sys->MapLookup(sys,ASCIIZ("CN2_66"))) >= 0);

  assert((ISO_IN1=sys->MapLookup(sys,ASCIIZ("CN1_64"))) >= 0);
  assert((ISO_IN2=sys->MapLookup(sys,ASCIIZ("CN1_66"))) >= 0);
  assert((EN_ISO_OUT1_N=sys->MapLookup(sys,ASCIIZ("CN1_68"))) >= 0);
  assert((EN_ISO_OUT2_N=sys->MapLookup(sys,ASCIIZ("CN1_70"))) >= 0);
  assert((IN_DIO_1=sys->MapLookup(sys,ASCIIZ("CN1_84"))) >= 0);
  assert((EN_HS_OUT1=sys->MapLookup(sys,ASCIIZ("CN1_72"))) >= 0);
  assert((IN_DIO_2=sys->MapLookup(sys,ASCIIZ("CN1_86"))) >= 0);
  assert((EN_HS_OUT2=sys->MapLookup(sys,ASCIIZ("CN1_74"))) >= 0);
  assert((IN_DIO_3=sys->MapLookup(sys,ASCIIZ("CN1_88"))) >= 0);
  assert((EN_LS_OUT_3=sys->MapLookup(sys,ASCIIZ("CN1_80"))) >= 0);
  assert((IN_DIO_4=sys->MapLookup(sys,ASCIIZ("CN1_90"))) >= 0);
  assert((EN_LS_OUT_4=sys->MapLookup(sys,ASCIIZ("CN1_82"))) >= 0);
  assert((ADC_CLK=sys->MapLookup(sys,ASCIIZ("CN1_89"))) >= 0);
  assert((BUF_ADC_DATA=sys->MapLookup(sys,ASCIIZ("CN1_91"))) >= 0);
  assert((ADC_CS_N=sys->MapLookup(sys,ASCIIZ("CN1_93"))) >= 0);
  assert((SBC_ADC_SEL0=sys->MapLookup(sys,ASCIIZ("CN1_77"))) >= 0);
  assert((SBC_ADC_SEL1=sys->MapLookup(sys,ASCIIZ("CN1_79"))) >= 0);
  assert((SBC_ADC_SEL2=sys->MapLookup(sys,ASCIIZ("CN1_81"))) >= 0);
  assert((SBC_GAIN_0=sys->MapLookup(sys,ASCIIZ("CN1_76"))) >= 0);
  assert((SBC_GAIN_1=sys->MapLookup(sys,ASCIIZ("CN1_78"))) >= 0);
  // free region here
  DIOTEST(EN_ISO_OUT1_N,ISO_IN1);
  DIOTEST(EN_ISO_OUT2_N,ISO_IN2);

  DIOSetValue(DIO,EN_ISO_OUT1_N,EN_ISO_OUT2_N,EN_LS_OUT3);

}
